function [Lon, Lat] = op_shiftcoast(long,lat)
%
% This routine will make the coastline go from
% 0 to 360 as opposed to from -180 to 180.
%
% OPeNDAP Science Team
% Copyright 2008
% $Version 2.0.0$

j = 0;
imax = length(long);
for i=1:imax-1,

   j = j + 1;
   lonp(j) = long(i);
   latp(j) = lat(i);

   prod = long(i) * long(i+1);
   if prod <= 0
      j = j + 1;
      lonp(j) = nan;
      latp(j) = nan;
   end
   if long(i) == 0 & long(i+1) > 0
      j = j - 1;
      lonp(j) = nan;
      latp(j) = nan;
      j = j + 1;
      lonp(j) = long(i);
      latp(j) = lat(i);
   end
end

Lat = latp;
nn = find(lonp < 0);
Lon = lonp;
Lon(nn) = 360 + lonp(nn);

return

